package jMoneyAtHome;

import java.sql.*;
/**
 *
 * @author  markus
 */
public class DBConnectivity {
  
  protected DBConnectivity(javax.swing.JFrame parent, String h, String d) {
    baseFrame=(MainGUI)parent;
    hostname = h;
    database = d;
  }
  
  /** establishes connection to DB
   * @param user User to use for connection to DB
   * @param password password to use for connection to DB
   */
  protected boolean establishConnection(String u, String p) {
    user     = u;
    password = p;
    try {
      Class.forName("org.gjt.mm.mysql.Driver").newInstance();
      // establish connetion to DB
      String url =  "jdbc:mysql://"+hostname+"/"+database+"?user="+user+"&password="+password;
      connection = DriverManager.getConnection(url);
      return true;
    } catch (Exception noSuchDriver) {
      baseFrame.errorDialog(noSuchDriver.toString());
      return false;
    }
  }
  
  protected boolean closeConnection() {
    try {
        connection.close();
        return true;
      } catch (Exception e) {
        baseFrame.errorDialog("There is no connection to DB!");      
        return false;
      }    
  }
  
  protected ResultSet query(String query) {
    try {
      Statement s = connection.createStatement();
      ResultSet rs = s.executeQuery(query);    
      return rs;
    } catch (Exception e) {
      //baseFrame.errorDialog("Something went wrong while executing your query!");
      baseFrame.errorDialog(e.toString());
      return null;
    }
  }
  
  protected boolean insertData(String query) {
    try {
      Statement s = connection.createStatement();
      s.execute(query);    
      return true;
    } catch (Exception e) {
      //baseFrame.errorDialog("Something went wrong while executing your query!");
      baseFrame.errorDialog(e.toString());
      return false;
    }
  }
  
  MainGUI baseFrame; 
  private Connection connection;
  private String user, password, hostname, database;
}
