package jMoneyAtHome;
import java.sql.*;
import java.awt.*;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import javax.swing.table.*;
import javax.swing.*;


/** This is the main class. This class builds the main GUI.
 *
 * @author markus
 */
public class MainGUI extends javax.swing.JFrame {
  
  /** Creates new form MainGUI */
  public MainGUI() {
    readPrefs();
    initComponents();
  }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
  private void initComponents() {//GEN-BEGIN:initComponents
    mainPanel = new javax.swing.JPanel();
    scrollPane = new javax.swing.JScrollPane();
    overviePanel = new javax.swing.JPanel();
    overviewScrollPane = new javax.swing.JScrollPane();
    overviewTextArea = new javax.swing.JTextArea();
    jPanel1 = new javax.swing.JPanel();
    overviewLabel = new javax.swing.JLabel();
    mainToolBar = new javax.swing.JToolBar();
    connectButton = new javax.swing.JButton();
    purchaseButton = new javax.swing.JButton();
    refreshButton = new javax.swing.JButton();
    statusBar = new javax.swing.JLabel();
    mainMenuBar = new javax.swing.JMenuBar();
    fileMenu = new javax.swing.JMenu();
    connectItem = new javax.swing.JMenuItem();
    disconnectItem = new javax.swing.JMenuItem();
    jSeparator1 = new javax.swing.JSeparator();
    preferencesItem = new javax.swing.JMenuItem();
    jSeparator2 = new javax.swing.JSeparator();
    exitItem = new javax.swing.JMenuItem();
    helpMenu = new javax.swing.JMenu();
    aboutItem = new javax.swing.JMenuItem();

    setTitle("jMoney@Home");
    setIconImage(Toolkit.getDefaultToolkit().createImage(MainGUI.class.getResource("/jMoneyAtHome/pics/icon.gif")));
    setName("mainGUI");
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        exitForm(evt);
      }
    });

    mainPanel.setLayout(new java.awt.BorderLayout());

    mainPanel.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
    mainPanel.setMinimumSize(new java.awt.Dimension(500, 300));
    mainPanel.setPreferredSize(new java.awt.Dimension(700, 450));
    mainPanel.add(scrollPane, java.awt.BorderLayout.CENTER);

    overviePanel.setLayout(new java.awt.BorderLayout(5, 5));

    overviePanel.setMinimumSize(new java.awt.Dimension(100, 100));
    overviewTextArea.setBackground(new java.awt.Color(200, 200, 200));
    overviewTextArea.setEditable(false);
    overviewScrollPane.setViewportView(overviewTextArea);

    overviePanel.add(overviewScrollPane, java.awt.BorderLayout.CENTER);

    jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 5, 2));

    overviewLabel.setText("Overview");
    jPanel1.add(overviewLabel);

    overviePanel.add(jPanel1, java.awt.BorderLayout.NORTH);

    mainPanel.add(overviePanel, java.awt.BorderLayout.EAST);

    getContentPane().add(mainPanel, java.awt.BorderLayout.CENTER);

    mainToolBar.setDoubleBuffered(true);
    connectButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jMoneyAtHome/pics/disconnected.gif")));
    connectButton.setFocusPainted(false);
    connectButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        connectButtonActionPerformed(evt);
      }
    });

    mainToolBar.add(connectButton);

    purchaseButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jMoneyAtHome/pics/basket.gif")));
    purchaseButton.setFocusPainted(false);
    purchaseButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        purchaseButtonActionPerformed(evt);
      }
    });

    mainToolBar.add(purchaseButton);

    refreshButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jMoneyAtHome/pics/refresh.gif")));
    refreshButton.setFocusPainted(false);
    refreshButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        refreshButtonActionPerformed(evt);
      }
    });

    mainToolBar.add(refreshButton);

    getContentPane().add(mainToolBar, java.awt.BorderLayout.NORTH);

    statusBar.setText(" ");
    statusBar.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
    statusBar.setDoubleBuffered(true);
    getContentPane().add(statusBar, java.awt.BorderLayout.SOUTH);

    mainMenuBar.setDoubleBuffered(true);
    fileMenu.setText("File");
    connectItem.setText("Connect");
    connectItem.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        connectItemActionPerformed(evt);
      }
    });

    fileMenu.add(connectItem);
    disconnectItem.setText("Disconnect");
    disconnectItem.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        disconnectItemActionPerformed(evt);
      }
    });

    fileMenu.add(disconnectItem);
    fileMenu.add(jSeparator1);
    preferencesItem.setText("Preferences");
    preferencesItem.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        preferencesItemActionPerformed(evt);
      }
    });

    fileMenu.add(preferencesItem);
    fileMenu.add(jSeparator2);
    exitItem.setText("Exit");
    exitItem.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        exitItemActionPerformed(evt);
      }
    });

    fileMenu.add(exitItem);
    mainMenuBar.add(fileMenu);
    helpMenu.setText("Help");
    helpMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        helpMenuActionPerformed(evt);
      }
    });

    aboutItem.setText("About");
    aboutItem.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        aboutItemActionPerformed(evt);
      }
    });

    helpMenu.add(aboutItem);
    mainMenuBar.add(helpMenu);
    setJMenuBar(mainMenuBar);

    pack();
  }//GEN-END:initComponents

  private void refreshButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshButtonActionPerformed
    if (alreadyConnected) { 
      refreshView();
    } else {
      errorDialog("Not connected to DB!");
    }  
  }//GEN-LAST:event_refreshButtonActionPerformed

  private void purchaseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_purchaseButtonActionPerformed
    if (alreadyConnected) {
      PurchaseDialog dlg = new PurchaseDialog(this,true,dbcon);
      Dimension dlgSize = dlg.getSize();
      Dimension frmSize = getSize();
      Point loc = getLocation();
      dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
      dlg.show();
    } else {
      errorDialog("Not connected to DB!");
    }
  }//GEN-LAST:event_purchaseButtonActionPerformed

  private void connectItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connectItemActionPerformed
    if (!alreadyConnected) {
      connectDB();
      refreshView();
    } else {
      errorDialog("Already Connected to DB!");      
    }
  }//GEN-LAST:event_connectItemActionPerformed

  private void disconnectItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_disconnectItemActionPerformed
    if (alreadyConnected) {
      disconnectDB();
    } else {
      errorDialog("There is no connection to DB!");      
    }
  }//GEN-LAST:event_disconnectItemActionPerformed

  private void preferencesItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_preferencesItemActionPerformed
    // Add your handling code here:
    PrefsDialog dlg = new PrefsDialog(this,true);
    Dimension dlgSize = dlg.getSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.show();
  }//GEN-LAST:event_preferencesItemActionPerformed

  private void connectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connectButtonActionPerformed
    if (alreadyConnected) {
      disconnectDB();
    } else {
      connectDB();
      refreshView();
    }
  }//GEN-LAST:event_connectButtonActionPerformed

  protected void setConnectButtonIcon() {
    if (alreadyConnected) {
      connectButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jMoneyAtHome/pics/connected.gif")));
    } else {
      connectButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jMoneyAtHome/pics/disconnected.gif")));
    }
  }

  protected void refreshView() {
      // creating main table
      scrollPane.setViewportView(null);
      model = new MyTableModel(dbcon.query("SELECT Date,What,Costs,Who_Paid FROM jMoneyAtHome ORDER BY Date"));
      table =  new JTable(model);
      scrollPane.setViewportView(table); 
      overviewTextArea.setText("");
      
      // Stelle Anfrage an DB fr Overview Statistik
      try {
        ResultSet query1,query2;
        String query, name;

        query1 = dbcon.query("SELECT DISTINCT Who_paid FROM jMoneyAtHome");
        while (query1.next()) {
          query = "SELECT SUM(Costs) Costs FROM jMoneyAtHome WHERE Who_paid=\""+query1.getString("Who_paid")+"\"";
          name = query1.getString("Who_paid");
          query2 = dbcon.query(query);
          while (query2.next()) {
           overviewTextArea.append(name+"\n");
           overviewTextArea.append(Float.toString(query2.getFloat("Costs"))+"\n\n");
          }
        }
      } catch (Exception e) { System.out.println(e);}
      
      
  }
  
  protected void connectDB() {
    if ((hostname.length()<1)||(database.length()<1)) {
        errorDialog("Hostname or Database not set!");
    } else {
      if (useConnectDialog) {
        ConnectDialog dlg = new ConnectDialog(this,true);
        Dimension dlgSize = dlg.getSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.show();
      } else {
        if (dbcon.establishConnection(username, password)) {
          statusBar.setText("Connection to DB established...");
          alreadyConnected=true;
          setConnectButtonIcon(); 
        }
      }
    }
  }

  protected void disconnectDB() {
    if (dbcon.closeConnection()) {
      statusBar.setText("Disconnected from DB...");
      overviewTextArea.setText("");
      scrollPane.setViewportView(null);
      alreadyConnected = false;
      setConnectButtonIcon();
    }
  }
  
  private void aboutItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutItemActionPerformed
    // Add your handling code here:
    AboutDialog dlg = new AboutDialog(this,true);
    Dimension dlgSize = dlg.getSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.show();
  }//GEN-LAST:event_aboutItemActionPerformed

  private void helpMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_helpMenuActionPerformed
    // Add your handling code here:
  }//GEN-LAST:event_helpMenuActionPerformed

  private void exitItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitItemActionPerformed
    System.exit(0);
  }//GEN-LAST:event_exitItemActionPerformed

    /** Exit the Application
     * @param evt  */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
      System.exit(0);
    }//GEN-LAST:event_exitForm

  private void readPrefs() {
    try {
      
      /* print system details
      System.out.println("OS Name: "+System.getProperty("os.name"));
      System.out.println("OS Arch: "+System.getProperty("os.arch"));
      System.out.println("OS Version: "+System.getProperty("os.version"));
      System.out.println("User Dir: "+System.getProperty("user.dir"));
      System.out.println("User Home: "+System.getProperty("user.home")); 
      */

      String file;
      file = System.getProperty("user.home")+System.getProperty("file.separator")+".jMoneyAtHome";
      BufferedReader prefsIN =  new BufferedReader(new FileReader(file));
      int index;
      String dummy;
      String line;
      while ((line = prefsIN.readLine()) != null) {
        dummy = "";
        index = line.indexOf("=");
        // get parameter of the line currently read
        dummy = line.substring(0,index-1);
        dummy = dummy.trim();
        
        if (dummy.equals("hostname")) { 
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          hostname=dummy;
        } else if (dummy.equals("database")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          database=dummy;
        } else if (dummy.equals("port")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          port =  dummy;
        } else if (dummy.equals("username")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          username = dummy;
        } else if (dummy.equals("password")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          password = dummy;
        } else if (dummy.equals("name")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          name = dummy;
        }
        if ((username.length()<1)||(password.length()<1)) {
          useConnectDialog =  true;
        } else {
          useConnectDialog =  false;
        }
      }
      prefsIN.close();      
    } catch (IOException e) {
    }
    dbcon = new DBConnectivity(this, hostname, database);
  }
  
  /** This method builds up an error message dialog.
   * @param error Holds the error message, which should be displayed.
   */  
  protected void errorDialog(String error) {
    ErrorDlg errorDlg = new ErrorDlg(this,true,error);
    Dimension errorDlgSize = errorDlg.getSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    errorDlg.setLocation((frmSize.width - errorDlgSize.width) / 2 + loc.x, (frmSize.height - errorDlgSize.height) / 2 + loc.y);
    errorDlg.show();
  }    
    
    
    /** "Main" method
     * @param args the command line arguments
     */
    public static void main(String args[]) {
      //Center the window
      MainGUI frame=new MainGUI();
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension frameSize = frame.getSize();
      if (frameSize.height > screenSize.height) {
        frameSize.height = screenSize.height;
      }
      if (frameSize.width > screenSize.width) {
        frameSize.width = screenSize.width;
      }
      frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
      frame.show();
    }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton connectButton;
  private javax.swing.JLabel overviewLabel;
  private javax.swing.JMenu fileMenu;
  private javax.swing.JMenuBar mainMenuBar;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JSeparator jSeparator2;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JTextArea overviewTextArea;
  private javax.swing.JScrollPane overviewScrollPane;
  private javax.swing.JButton refreshButton;
  private javax.swing.JMenuItem preferencesItem;
  private javax.swing.JPanel overviePanel;
  private javax.swing.JToolBar mainToolBar;
  private javax.swing.JMenuItem connectItem;
  protected javax.swing.JScrollPane scrollPane;
  private javax.swing.JButton purchaseButton;
  private javax.swing.JMenuItem exitItem;
  private javax.swing.JMenuItem disconnectItem;
  private javax.swing.JPanel mainPanel;
  private javax.swing.JLabel statusBar;
  private javax.swing.JMenuItem aboutItem;
  private javax.swing.JMenu helpMenu;
  // End of variables declaration//GEN-END:variables

  // variables for MySQL server information
  protected String hostname = "";
  protected String database = "";
  protected String port = "";
  protected String name = "";
  protected String password = "";
  protected String username = "";
  protected boolean useConnectDialog = true;
  protected boolean alreadyConnected = false;
  /**
   */  
  DBConnectivity dbcon;
  TableModel model;
  JTable table;


class MyTableModel extends AbstractTableModel implements javax.swing.event.TableModelListener {

  /** Main constructor
   * @param myResultSet With this parameter the tablemodel gets its data
   */  
  public MyTableModel(ResultSet myResultSet) {
    rs = myResultSet;
    try {
      rsmd = rs.getMetaData();
    } catch (SQLException e) {
      System.out.println("Fehler: "+e);
    }
  }

  public int getColumnCount() {
    try {
      return rsmd.getColumnCount();
    } catch (SQLException e) {
      System.out.println("Fehler: "+e);
      return 0;
    }
  }
  
  public String getColumnName(int c) {
    try {
      return rsmd.getColumnName(c+1);
    } catch (SQLException e) {
      System.out.println("Fehler: "+e);
      return "";
    }
  }
  
  public int getRowCount() {
    try {
      rs.last();
      return rs.getRow();
    } catch (SQLException e) {
      System.out.println("Fehler: "+e);
      return 0;
    }
  }
  
  public Object getValueAt(int param, int param1) {
    try {
      rs.absolute(param+1);
      return rs.getObject(param1+1);
    } catch (SQLException e) {
      System.out.println("Fehler: "+e);
      return null;
    }
  }
  
  public void tableChanged(javax.swing.event.TableModelEvent tableModelEvent) {
    fireTableChanged(tableModelEvent);
  }  
  
  private ResultSet rs;
  private ResultSetMetaData rsmd;
}

}

