package jMoneyAtHome;
import java.awt.Dimension;
import java.awt.Point;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author  markus
 */
public class PrefsDialog extends javax.swing.JDialog {
  /** Creates new form PrefsDialog */
  protected PrefsDialog(java.awt.Frame parent, boolean modal) {
    super(parent, modal);  
    baseFrame = (MainGUI)parent;

    // read preferences out of file
    readPrefs();
    // check, if username and password is set
    if ((username.length()<1)||(password.length()<1)) {
      saveUser=false;
    } else {
      saveUser=true;
    }
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
    buttonPanel = new javax.swing.JPanel();
    okButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();
    picturePanel = new javax.swing.JPanel();
    pricture = new javax.swing.JLabel();
    mainPanel = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    serverPanel = new javax.swing.JPanel();
    hostLabel = new javax.swing.JLabel();
    hostTextField = new javax.swing.JTextField();
    databaseLabel = new javax.swing.JLabel();
    databaseTextField = new javax.swing.JTextField();
    portLabel = new javax.swing.JLabel();
    portTextField = new javax.swing.JTextField();
    nameLabel = new javax.swing.JLabel();
    nameTextField = new javax.swing.JTextField();
    userPanel = new javax.swing.JPanel();
    saveUserCheckBox = new javax.swing.JCheckBox();
    userFieldPanel = new javax.swing.JPanel();
    userLabel = new javax.swing.JLabel();
    userTextField = new javax.swing.JTextField();
    passwordLabel = new javax.swing.JLabel();
    passwordField = new javax.swing.JPasswordField();
    titlePanel = new javax.swing.JPanel();
    jLabel3 = new javax.swing.JLabel();

    setTitle("Preferences");
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        closeDialog(evt);
      }
    });

    buttonPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    okButton.setText("OK");
    okButton.setBorder(new javax.swing.border.EtchedBorder());
    okButton.setFocusPainted(false);
    okButton.setMaximumSize(new java.awt.Dimension(100, 30));
    okButton.setPreferredSize(new java.awt.Dimension(70, 21));
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        okButtonActionPerformed(evt);
      }
    });

    buttonPanel.add(okButton);

    cancelButton.setText("Cancel");
    cancelButton.setBorder(new javax.swing.border.EtchedBorder());
    cancelButton.setPreferredSize(new java.awt.Dimension(70, 21));
    cancelButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cancelButtonActionPerformed(evt);
      }
    });

    buttonPanel.add(cancelButton);

    getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);

    pricture.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jMoneyAtHome/pics/prefs.gif")));
    pricture.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
    picturePanel.add(pricture);

    getContentPane().add(picturePanel, java.awt.BorderLayout.WEST);

    mainPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel2.setLayout(new java.awt.BorderLayout(5, 5));

    jPanel2.setBorder(new javax.swing.border.TitledBorder("Database Connectivity"));
    serverPanel.setLayout(new java.awt.GridLayout(4, 2, 0, 4));

    serverPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 1, 1, 1)));
    hostLabel.setText("Hostname:");
    serverPanel.add(hostLabel);

    hostTextField.setText(hostname);
    hostTextField.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
    serverPanel.add(hostTextField);

    databaseLabel.setText("Database:");
    serverPanel.add(databaseLabel);

    databaseTextField.setText(database);
    databaseTextField.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
    serverPanel.add(databaseTextField);

    portLabel.setText("Port:");
    serverPanel.add(portLabel);

    portTextField.setText(port);
    portTextField.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
    serverPanel.add(portTextField);

    nameLabel.setText("Your Name:");
    serverPanel.add(nameLabel);

    nameTextField.setText(name);
    serverPanel.add(nameTextField);

    jPanel2.add(serverPanel, java.awt.BorderLayout.NORTH);

    userPanel.setLayout(new java.awt.BorderLayout());

    saveUserCheckBox.setSelected(saveUser);
    saveUserCheckBox.setText("Save Username and Password");
    saveUserCheckBox.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
    saveUserCheckBox.setDoubleBuffered(true);
    saveUserCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        saveUserCheckBoxActionPerformed(evt);
      }
    });

    userPanel.add(saveUserCheckBox, java.awt.BorderLayout.NORTH);

    userFieldPanel.setLayout(new java.awt.GridLayout(2, 2, 0, 5));

    userLabel.setText("Username:");
    userLabel.setDoubleBuffered(true);
    userLabel.setEnabled(saveUser);
    userFieldPanel.add(userLabel);

    userTextField.setEditable(saveUser);
    userTextField.setText(username);
    userTextField.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
    userTextField.setDoubleBuffered(true);
    userFieldPanel.add(userTextField);

    passwordLabel.setText("Password:");
    passwordLabel.setDoubleBuffered(true);
    passwordLabel.setEnabled(saveUser);
    userFieldPanel.add(passwordLabel);

    passwordField.setEditable(saveUser);
    passwordField.setText(password);
    passwordField.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
    passwordField.setDoubleBuffered(true);
    userFieldPanel.add(passwordField);

    userPanel.add(userFieldPanel, java.awt.BorderLayout.SOUTH);

    jPanel2.add(userPanel, java.awt.BorderLayout.CENTER);

    mainPanel.add(jPanel2);

    getContentPane().add(mainPanel, java.awt.BorderLayout.CENTER);

    titlePanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jLabel3.setFont(new java.awt.Font("Dialog", 1, 18));
    jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    jLabel3.setText("Preferences");
    titlePanel.add(jLabel3);

    getContentPane().add(titlePanel, java.awt.BorderLayout.NORTH);

    pack();
  }//GEN-END:initComponents

  private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
    hostname = hostTextField.getText();
    database = databaseTextField.getText();
    port     = portTextField.getText();
    name     = nameTextField.getText();
    if ((hostname.length()<1)||(database.length()<1)) {
      baseFrame.errorDialog("Hostname or database not set!");
    } else {
      baseFrame.hostname = hostname;
      baseFrame.database = database;
      baseFrame.port     = port;
      baseFrame.name     = name;
      // if Username and Password is set, disable ConnectDialog and set the 
      // username and password variable in main window
      if (saveUserCheckBox.isSelected()) {
        username = userTextField.getText();
        password = new String(passwordField.getPassword());
        if ((username.length()<1)||(password.length()<1)) {
          baseFrame.errorDialog("Username or password not set!");
        } else {         
          baseFrame.useConnectDialog = false;
          baseFrame.username = username;
          baseFrame.password = password;
          writePrefs();
          setVisible(false);
          dispose();
        }
      } else {
        baseFrame.useConnectDialog = true;
        baseFrame.username = "";
        baseFrame.password = "";
        writePrefs();
        setVisible(false);
        dispose();
      }
      
    }
  }//GEN-LAST:event_okButtonActionPerformed

  private void saveUserCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveUserCheckBoxActionPerformed
    if (saveUserCheckBox.isSelected()) {
      userTextField.setEditable(true);
      passwordField.setEditable(true);
      userLabel.setEnabled(true);
      passwordLabel.setEnabled(true);
    } else {
      userTextField.setEditable(false);
      passwordField.setEditable(false);
      userLabel.setEnabled(false);
      passwordLabel.setEnabled(false);
    }
  }//GEN-LAST:event_saveUserCheckBoxActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
    setVisible(false);
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  /** Closes the dialog */
  private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
    setVisible(false);
    dispose();
  }//GEN-LAST:event_closeDialog
  
  private void readPrefs() {
    try {
      String file;
      file = System.getProperty("user.home")+System.getProperty("file.separator")+".jMoneyAtHome";
      BufferedReader prefsIN =  new BufferedReader(new FileReader(file));
      int index;
      String dummy;
      String line;
      // read every line of the preference file
      while ((line = prefsIN.readLine()) != null) {
        dummy = "";
        index = line.indexOf("=");
        // get parameter of the line currently read
        dummy = line.substring(0,index-1);
        dummy = dummy.trim();
        if (dummy.equals("hostname")) { 
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          hostname=dummy;
        } else if (dummy.equals("database")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          database=dummy;
        } else if (dummy.equals("port")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          port =  dummy;
        } else if (dummy.equals("username")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          username = dummy;
        } else if (dummy.equals("password")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          password = dummy;
        } else if (dummy.equals("name")) {
          // get Value of parameter
          dummy = line.substring(index+1,line.length());
          dummy = dummy.trim();
          name = dummy;
        }
      }
      prefsIN.close();      
    } catch (IOException e) {
    }
  }
 
  private void writePrefs() {
    try {
      String file;
      file = System.getProperty("user.home")+System.getProperty("file.separator")+".jMoneyAtHome";
      BufferedWriter prefsOUT =  new BufferedWriter(new FileWriter(file));        
      prefsOUT.write("hostname = "+hostTextField.getText());     prefsOUT.newLine();
      prefsOUT.write("database = "+databaseTextField.getText()); prefsOUT.newLine();
      prefsOUT.write("port     = "+portTextField.getText());     prefsOUT.newLine();
      prefsOUT.write("name     = "+nameTextField.getText());     prefsOUT.newLine();
      if (saveUserCheckBox.isSelected()) {
        prefsOUT.write("username = "+userTextField.getText());   prefsOUT.newLine();
        password = new String(passwordField.getPassword());
        prefsOUT.write("password = "+password);                  prefsOUT.newLine();
      } else {
        prefsOUT.write("username = ");                           prefsOUT.newLine();
        prefsOUT.write("password = ");                           prefsOUT.newLine();
      }
      prefsOUT.close();
    } catch (IOException e) {
      System.out.println(e);
    }
  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel userPanel;
  private javax.swing.JLabel databaseLabel;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JLabel portLabel;
  private javax.swing.JPanel buttonPanel;
  private javax.swing.JButton okButton;
  private javax.swing.JLabel hostLabel;
  private javax.swing.JCheckBox saveUserCheckBox;
  private javax.swing.JLabel userLabel;
  private javax.swing.JLabel nameLabel;
  private javax.swing.JPanel picturePanel;
  private javax.swing.JPasswordField passwordField;
  private javax.swing.JLabel passwordLabel;
  private javax.swing.JPanel userFieldPanel;
  private javax.swing.JTextField databaseTextField;
  private javax.swing.JLabel pricture;
  private javax.swing.JPanel titlePanel;
  private javax.swing.JTextField portTextField;
  private javax.swing.JButton cancelButton;
  private javax.swing.JPanel mainPanel;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JTextField hostTextField;
  private javax.swing.JTextField userTextField;
  private javax.swing.JTextField nameTextField;
  private javax.swing.JPanel serverPanel;
  // End of variables declaration//GEN-END:variables

  private boolean saveUser=false;
  MainGUI baseFrame;
  private String hostname = "localhost";
  private String database = "";
  private String port     = "3306";
  private String password = "";
  private String username = "";
  private String name     = "";
  
}
